/**************************************************************************
 FILE:
	ind_pcb.h

 @(#)ind_pcb.h 1.19 92/11/09 Copyr 1986 Sun Micro

 DESCRIPTION:
 **************************************************************************/

/*
 * Common structure pcb for IND protocol implementations.
 * Here are stored pointers to local and foreign host table
 * entries, local and foreign socket numbers, and pointers
 * up (to a socket structure) and down (to a protocol-specific)
 * control block.
 */
struct indpcb {
	struct	indpcb *next,*prev;	/* pointers to other pcb's */
	struct	indpcb *head;		/* pointer back to chain of indpcb's
					   for this protocol */
	unsigned type;			/* protocol type, e.g., NBSPROTO_IND */
	unsigned flags;			/* common state and option flags */
#define		IND_FADDR_SET	0x01	
#define		IND_LADDR_SET	0x02
#define		IND_RCV_RAW	0x04
#define		IND_RCV_ER	0x08	/* requires IND_RCV_RAW) */
#define 	IND_SEND_OPT	0x10	/* first byte is an option length 
					 * followed by options followed 
					 * by data */
#define		IND_TTL_SET	0x20	/* Lifetime has been set */

/* ICNCFIX by -TH- for long term ping. */
#define		IND_ECHOREQ	0x40	/* Send echo request, not data */
#define		IND_ECHORSP	0x80	/* Send echo response, not data */
/* End of fix */

/* ICNCFIX by -TH- for long term ping.  The above two flags are also user
   settable.
#define 	IND_USER_SETABLE (IND_RCV_RAW|IND_RCV_ER|IND_SEND_OPT) */
#define         IND_USER_SETABLE (IND_RCV_RAW|IND_RCV_ER|IND_SEND_OPT|IND_ECHOREQ|IND_ECHORSP)
/* End of fix */

	struct	mbuf		*faddr;	/* foreign host */
	int			fnsel;
	struct	mbuf		*laddr;	/* local host */
	int			lnsel;
	struct	socket *socket;		/* back pointer to socket */
	caddr_t	ppcb;			/* pointer to per-protocol pcb */
	int			ttl;
};


#define	sotoindpcb(so)		((struct indpcb *)((so)->so_pcb))

#ifdef KERNEL
struct indpcb 	*ind_pcblookup();
#endif
