/* 
 * @(#)ses_impl.h 1.12 87/10/23 Copyr 1986 Sun Micro
 */
#define _SES_IMPL

#ifdef AUTOFACT
/*
 * MAP/TOP compatible reflect parameter defs
 */
extern REFLECT s_reflect;
extern u_char state_map[];
extern u_char event_map[];
unsigned state_to_rel();
unsigned event_to_rel();
void	set_state();
void	set_event();
void	set_si();
#endif AUTOFACT

#define SES_VERSION	1		/* protocol version of this implementation */

#define SES_DFLT_DTIME	30		/* default session disconnect time */

/* 
 * Global variables for this session instance 
 */
extern XSEL	ses_tsel;		/* default for this session entity */

extern struct protosw *ses_tp_proto;
/*
 * flags.
 */

#define SES_MGMT_PROC	0x0001	/* Session management process on this TCB */
#define SES_DBG_PROC	0x0002	/* debugging process on this TCB -- can be same
				as management process */
/*
 *  Client listener tables
 */
typedef struct ses_listner {
	struct ses_listner *next;
	int	hash;		/* hashed session selector for fast lookup */
	XSEL ssel;		/* listener address (if SSEL supplied)	   */
	XSEL tsel;		/* listener address (if no SSEL supplied)  */
	struct protosw	*proto;		
				/* args returned to listener when new channel
				 *  instance returned */
	int	reference_cnt;	/* number of times listener requested this
				 * address */
} SES_LISTENER;


/*
 *  Default internal paramter values
 */
#define S_DTIMER		256	/* session layer disconnect timer */


typedef enum { 		/* session events types */

	/* session-user (via session interface event) */
	/* NOTE - order of events must match SES_UEVENT */
	SU_CON_REQ,		/* +connect request */
	SU_CON_RSP_A,		/* +connect (accept) response */
	SU_CON_RSP_R,		/* connect (reject) response */
	SU_DT_REQ,		/* +data request */
	SU_REL_REQ,		/* +release request */
	SU_REL_RSP_A,		/* +release (accept) response */
	/*SU_REL_RSP_R,		/* release (reject) response */
	SU_UAB_REQ,		/* +user-abort request */
	/*SU_EX_REQ,		/* +expedited data request */
	SU_ACTD_REQ,		/* activity-discard request */
	SU_ACTD_RSP,		/* activity-discard response */
	SU_ACTE_REQ,		/* activity-end request */
	SU_ACTE_RSP,		/* activity-end response */
	SU_ACTI_REQ,  		/* activity-interrupt request */
	SU_ACTI_RSP,	  	/* activity-interrupt response */
	SU_ACTR_REQ,		/* activity-resume request */
	SU_ACTS_REQ,		/* activity-start request */
	SU_CD_REQ,		/* capability-data request */
	SU_CD_RSP,		/* capability-data response */
	SU_CG_REQ,		/* control-give request */
	SU_GT_REQ,		/* token-give request */
	SU_PT_REQ,		/* token-please request */
	/*SU_RSYN_REQ_A,	/* resynchronize (abandon) request */
	/*SU_RSYN_REQ_R,	/* resynchronize (restart) request */
	/*SU_RSYN_REQ_S,	/* resynchronize (set) request */
	/*SU_RSYN_RSP,		/* resynchronize response */
	/*SU_SYNMA_REQ,		/* sync-major request */
	/*SU_SYNMA_RSP,		/* sync-major response */
	SU_SYNMI_REQ,		/* sync-minor request */
	SU_SYNMI_RSP,		/* sync-minor response */
	SU_TD_REQ,		/* typed-data request */
	SU_UER_REQ,		/* user-exception-report request */

	/* transport-service (via transport interface event) */
	TS_CON_CNF,	/* +connect confirmation */
	TS_CON_IND,	/* +connect indication */
	TS_DIS_IND,	/* +disconnect indication */
	/*TS_DAT_IND,	/* data indication (see SIDUs below) */

	/* system */
	SY_TIM_IND,	/* +timer indication */

	/* session-peer input SPDU */
	SIDU_AA,	/* +abort accept */
	SIDU_AB_NR,	/* +abort (not reuse) */
	/*SIDU_AB_R,	/* +abort (reuse) */
	SIDU_AC,	/* +accept */
	SIDU_CN,	/* +connect */
	SIDU_DN,	/* +disconnect */
	SIDU_DT,	/* +data transfer */
	/*SIDU_EX,	/* +expedited data */
	SIDU_FN_NR,	/* +finish (not reuse) */
	/*SIDU_FN_R,	/* +finish (reuse) */
	SIDU_RF_NR,	/* +refuse (not reuse) */
	/*SIDU_RF_R,	/* +refuse (reuse) */
	SIDU_AD,	/* activity discard */
	SIDU_ADA,	/* activity discard ack */
	SIDU_AE,	/* activity end */
	SIDU_MAA_AEA,	/* activity end ack & major sync ack */
	SIDU_AI,	/* activity interrupt */
	SIDU_AIA,	/* activity interrupt ack */
	SIDU_AR,	/* activity resume */
	SIDU_AS,	/* activity start */
	SIDU_CD,	/* capability data */
	SIDU_CDA,	/* capability data ack */
	SIDU_ED,	/* exception data */
	SIDU_ER,	/* exception report */
	SIDU_GT,	/* give token */
	SIDU_GTA,	/* give token ack */
	SIDU_GTC,	/* give token confirm */
	/*SIDU_MAP,	/* major sync point */
	SIDU_MIA,	/* minor sync ack */
	SIDU_MIP,	/* minor sync point */
	/*SIDU_NF,	/* not finished */
	SIDU_PR_MAA,	/* prepare (major sync ack) */
	SIDU_PR_RA,	/* prepare (resyncronize ack) */
	SIDU_PR_RS,	/* prepare (resyncronize) */
	SIDU_PT,	/* please tokens */
	/*SIDU_RA,	/* resyncronize ack */
	/*SIDU_RS_A,	/* resynchronize (abandon) */
	/*SIDU_RS_R,	/* resynchronize (restart) */
	/*SIDU_RS_S,	/* resynchronize (set) */
	SIDU_TD,	/* typed data */

	/* session-peer output SPDU */
	/*  NOTE - update ses_pdu.h if you change this */
	SODU_AA,	/* +abort accept */
	SODU_AB_NR,	/* +abort (not reuse) */
	SODU_AB_R,	/* +abort (reuse) */
	SODU_AC,	/* +accept */
	SODU_CN,	/* +connect */
	SODU_DN,	/* +disconnect */
	SODU_DT,	/* +data transfer */
	SODU_FN_NR,	/* +finish (not reuse) */
	SODU_FN_R,	/* +finish (reuse) */
	SODU_RF_NR,	/* +refuse (not reuse) */
	SODU_RF_R,	/* refuse (reuse) */
	SODU_EX,	/* +expedited data */
	SODU_AD,	/* activity discard */
	SODU_ADA,	/* activity discard ack */
	SODU_AE,	/* activity end */
	SODU_AEA,	/* activity end ack */
	SODU_AI,	/* activity interrupt */
	SODU_AIA,	/* activity interrupt ack */
	SODU_AR,	/* activity resume */
	SODU_AS,	/* activity start */
	SODU_CD,	/* capability data */
	SODU_CDA,	/* capability data ack */
	SODU_ED,	/* exception data */
	SODU_ER,	/* exception report */
	SODU_GT,	/* give token */
	SODU_GTA,	/* give token ack */
	SODU_GTC,	/* give token confirm */
	SODU_MAA,	/* major sync ack */
	SODU_MAP,	/* major sync point */
	SODU_MIA,	/* minor sync ack */
	SODU_MIP,	/* minor sync point */
	SODU_NF,	/* not finished */
	SODU_PR_MAA,	/* prepare (major sync ack) */
	SODU_PR_RA,	/* prepare (resyncronize ack) */
	SODU_PR_RS,	/* prepare (resyncronize) */
	SODU_PT,	/* please tokens */
	SODU_RA,	/* resyncronize ack */
	SODU_RS_A,	/* resynchronize (abandon) */
	SODU_RS_R,	/* resynchronize (restart) */
	SODU_RS_S,	/* resynchronize (set) */
	SODU_TD,	/* typed data */

	/* session service */
	/* NOTE - order of events must match SES_PEVENT */
	SS_CON_CNF_A,	/* +connection (accept) confirm */
	SS_CON_CNF_R,	/* +connection (reject) confirm */
	SS_CON_IND,	/* +connect indication */
	SS_DT_IND,	/* +data indication */
	SS_EX_IND,	/* +expedited-data indication */
	SS_PAB_IND,	/* +provider-abort indication */
	SS_REL_CNF_A,	/* +release (accept) confirm */
	/*SS_REL_CNF_R,	/* +release (reject) confirm */
	SS_REL_IND,	/* +release indication */
	SS_UAB_IND,	/* +user-abort indication */
	SS_ACTD_IND,	/* activity-discard indication */
	SS_ACTD_CNF,	/* activity-discard confirm */
	SS_ACTE_IND,	/* activity-discard indication */
	SS_ACTE_CNF,	/* activity-discard confirm */
	SS_ACTI_IND,	/* activity-interrupt indication */
	SS_ACTI_CNF,	/* activity-interrupt confirm */
	SS_ACTR_IND,	/* activity-resume indication */
	SS_ACTS_IND,	/* activity-start indication */
	SS_CD_IND,	/* activity-data indication */
	SS_CD_CNF,	/* activity-data confirm */
	SS_CG_IND,	/* control give indication */
	SS_GT_IND,	/* give-token indication */
	SS_PER_IND,	/* provider-exception-report indication */
	SS_PT_IND,	/* please-token indication */
	/*SS_RSYN_IND,	/* resynchronize indication */
	/*SS_RSYN_CNF,	/* resynchronize confirm */
	/*SS_SYNMA_IND,	/* sync-major indication */
	/*SS_SYNMA_CNF,	/* sync-major confirm */
	SS_SYNMI_IND,	/* sync-minor indication */
	SS_SYNMI_CNF,	/* sync-minor confirm */
	SS_TD_IND,	/* typed-data indication */
	SS_UER_IND,	/* user-exception-report indication */

	/* transport-user */
	TU_CON_REQ,	/* +connect request */
	TU_CON_RSP,	/* +connect response */
	TU_DIS_REQ,	/* +disconnect request */
	TU_EXP_REQ,	/* +expedited-data request */
	/*TU_DAT_REQ,	/* +data request */

	/* implementation generated */
	/*E_UPROTO,	/* protocol violation in user-generated event */
	/*E_PPROTO,	/* protocol violation in peer-generated event */
	/*E_DEATH,	/* free the machine */
	/*E_ABORT,	/* client went away */
	/*E_PERR,	/* protocol error */
	E_AMBG,		/* ambiguous event */
	E_NULL,		/* unknown event */
	N_EVENTS	/* upper bound of events */
} EVENT_TYPE;

typedef enum { /* state name and description */
	STA_01,		/* +idle, no transport connection */
	STA_01A,	/* +wait for SIDU_AA */
	STA_01B,	/* +wait for TS_CON_CNF */
	STA_01C,	/* +idle, transport connected */

	STA_02A,	/* +wait for SIDU_AC */
	STA_03,		/* +wait for SIDU_DN */

	STA_04A,	/* wait for SIDU_MAA or SIDU_PR_MAA */
	STA_04B,	/* wait for SIDU_AE or SIDU_PR_MAA */

	STA_05A,	/* wait for SIDU_RA or SIDU_PR_RA */
	STA_05B,	/* wait for SIDU_AIA or SIDU_PR_RA */
	STA_05C,	/* wait for SIDU_ADA or SIDU_PR_RA */

	STA_06,		/* wait for SIDU_RS_A or SIDU_RS_R or SIDU_RS_S after 
			   receiving SIDU_PR_RS */
	STA_08,		/* +wait for SU_CON_RSP_A or SU_CON_RSP_R */
	STA_09,		/* +wait for SU_REL_RSP_A or SU_REL_RSP_R */

	STA_10A,	/* wait for SU_SYNMA_RSP */
	STA_10B,	/* wait for SU_ACTE_RSP */

	STA_11A,	/* wait for SU_RSYN_RSP */
	STA_11B,	/* wait for SU_ACTI_RSP */
	STA_11C,	/* wait for SU_ACTD_RSP */

	STA_15A,	/* wait for SIDU_MAA or SIDU_AEA, after SIDU_PR_*  */
	STA_15B,	/* wait for SIDU_RS_* or SIDU_AI or SIDU_AD, 
			   after SIDU_PR_*  */
	STA_15C,	/* wait for SIDU_RA or SIDU_AIA or SIDU_ADA, 
			   after SIDU_PR_*  */

	STA_16,		/* +wait for TS_DIS_IND */
	STA_18,		/* wait for SIDU_GTA */
	STA_19,		/* wait for recovery request */
	STA_20,		/* wait for recovery request */
	STA_21,		/* wait for SIDU_CDA */
	STA_22,		/* wait for SU_CD_RSP */

	STA_713		/* +data transfer state */
} STATE_TYPE;

#define N_STATES	((unsigned)STA_713 + 1)
#define INITIAL_STATE	STA_01

typedef enum {	/* TPDU input fagmentation state -- see ses_pdu_ev */
	TPF_INITIAL = 0,/* have not started PDU */
	TPF_HDR_ASSEM,	/* have SI&LI; need header */
	TPF_PASS_DATA,	/* data pass-through for non-atomic DT SPDU */
	TPF_PASS_TDATA,	/* data pass-through for non-atomic TD SPDU */
	TPF_END_TSDU,	/* at end of TSDU */
	TPF_FLUSH	/* ignore the remaining data until eos */
} TPFRAG_STATE;

typedef enum {	/* SPDU output fagmentation state */
	SUF_INITIAL = 0,/* intial state no fragments outstanding */
	SUF_PASS,	/* data pass-through for non-atomic SPDU */
	SUF_FLUSH	/* flush data for non-atomic SPDU (set by FSM) */
} SUFRAG_STATE;

typedef enum {	/* data flow type */
	SES_FLOW_NORMAL,	/* normal data flow */
	SES_FLOW_EXPEDITED	/* expedited data flow */
} SES_FLOW_TYPE;

typedef enum {  /* concatenation categories for SPDUs with a TSDU */
		/* see section 6.3.7 of X.255 */
	CAT_0=0,		/* 0 */
	CAT_1,			/* 1 */
	CAT_2A,			/* 2 - Activity Start or Resume */
	CAT_2B,			/* 2 - Data Transfer and Cat 2 PDUs not
				       used in extended cat */
	CAT_2C,			/* 2 - Syn Point/Ack or Activity End */
	CAT_ER,			/* error (also see category_type definition) */
	CAT_NONE = -1		/* indicates beginning of TSDU */
} SES_CAT_TYPE;

/* type of concatenation */
#define	SES_CAT_BASIC		0
#define SES_CAT_EXTENDED	1

typedef enum {		/* kinds of resynchronizations */
	RESYNC_NO,		/* no resync in progress */
	RESYNC_A,		/* resynchronize abandon */
	RESYNC_R,		/* resynchronize restart */
	RESYNC_S,		/* resynchronize set 	 */
	RESYNC_DSC,		/* activity discard	 */
	RESYNC_INT		/* activity interrupt	 */
} SES_RESYNC_KIND;

typedef struct ses_timer {
	struct ses_timer	*next;
	struct SCB		*pcb;
	u_long			count;
} SES_TIMER;
/*
 * Session machine instance variables.  One machine per connection/client
 */
typedef struct SCB {
	/* pcb parameters */
	PCB_CNTL	cntl;		/* must be first */
	unsigned	flags;		/* session specific flags */
		     /* F_SND_BLOCKED		/* send blocked */
		     /* F_RCV_BLOCKED		/* receive blocked */
		     /* F_X_SND_BLOCKED		/* expedited send blocked */
		     /* F_X_RCV_BLOCKED		/* expedited receive blocked */
#define			SESF_FINAL	0x0010	/* final transition occured */
#define			SESF_CLDONE	0x0020	/* done with client */
#define			SESF_TIMERSET	0x0040	/* Timer enqueued -- prohibit
						 * duplicate timers on queue. */

	struct mbuf	*mbufaddr;	/* mbuf cluster containing this CB */
	struct mbuf	*mbufs;		/* mbuf's belonging to this pcb */

	/* event and state machine parameters */
	STATE_TYPE 	state;		/* current state of machine */
	EVENT_TYPE 	event;		/* most recent internal event posted */
	SES_TIMER	timer;

	/* interface fragmentation parameters */
	TPFRAG_STATE	ifrag_state;	/* current input fragment state */
	SES_CAT_TYPE	ifrag_category;	/* category of last SPDU in this TSDU*/
	SPDU		*ifrag_pdu_ptop;/* pointer to top of pdu stack */
	struct mbuf	*ifrag_queue;	/* queue for fragment reass. */
	unsigned	ifrag_qsize;	/* num of bytes on above queue */
	SUFRAG_STATE	ofrag_state;	/* current output fragment state */
	EVENT_TYPE	ofrag_event;	/* event associated with fragment */

	/*  interface paramters */
	struct protosw	*tp_protosw;	/* transport protocols switch */
	struct mbuf	*tp_queue;	/* queue for blocked transport events */
	struct protosw	*su_protosw;	/* session-user protocols switch */
	struct mbuf	*su_queue;	/* queue for blocked session-user 
					 *  events */

	/* session implementation parameters */
	SES_REF_ID	*pcd_cnref;	/* called-user connection reference */
	SES_REF_ID	*pcg_cnref;	/* calling-user connection reference */
	SES_REF_ID	*pcomm_cnref;	/* common connection reference */
	SES_ADD_REF	add_ref;	/* additional reference info */
	XSEL		f_ssel;		/* foriegn SSEL */
	XSEL		l_ssel;		/* local SSEL */
	SES_QOS		qos;		/* quality of service */
	struct mbuf	*m_pending;	/* data waiting for T-CONNECT-RSP*/
	struct mbuf	*event_q;	/* list of re-queued events */
	SES_FU_DOMAIN	su_req;		/* proposed session user requiremnts */
	PROFILE_VECTOR_ARRAY pv_all;	/* holds the stack profile vector */

	/* data stored for CN SPDU while awaiting T-CONNECT-CNF (more above?)*/
	SES_TOK_ASSIGN	tk_assign;	/* token setting option */
	SES_SPSN	init_spsn;	/* initial sync point serial num */

	/* session protocol parameters */
	u_short		version;	/* version number */
	short		popt;		/* protcol options selected */
	SES_FU_DOMAIN	fu_sel;		/* set of selected fu's */
	SES_TK_DOMAIN	tk_own;		/* set of tokens owned by SPM */
	SES_TK_DOMAIN	tk_avail;	/* set of tokens available to SPM */
	short		texp;		/* transport expedited service 
					   selected */
	short		v_tca;		/* transport connection acceptor */
	short		v_trr;		/* transport connection reusable */
	short		v_coll;		/* finish SPDU collision detected */
	SES_SPSN	v_A;		/* V(A): lowest spsn conf expected */
	SES_SPSN	v_M;		/* V(M): next spsn to be used */
	SES_SPSN	v_R;		/* V(R): lowest spsn for restart */
	short		v_sc;		/* Vsc: SES_SYNC_MI_RSP ok */
	short		v_act;		/* activity is in progress */
	short		v_next_act;	/* next value of v_act */
	SES_RESYNC_KIND	v_rsp;		/* kind of resync in progress */
	SES_ACT_ID	act_id;		/* identifier of activity */
	short		segment;	/* segmenting selected */
	MAX_TSDU	max_sdu;	/* maximum TSDU size */

	/* misc paramters */
	OSI_ADDR	*l_sap;
	OSI_ADDR	*f_sap;
	SPDU		pdu_stack1;	/* first element of pdu stack --
					    see ses_pdu_ev */
	SPDU		exp_pdu;	/* area for expedited pdu */
	SPDU		out_pdu;	/* tmp area for output pdu */
	TP_QOS_TYPE	tqos;		/* quality-of-service parameter */
	struct mbuf	*pdu_queue;	/* queue of pending SPDUs */
	LAYER_FLOW	flow;		/* flow control */
} SCB;

extern SCB		ses_hcb;	/* session header control block 
					 *  parameters */

/*
 *  FU_SUP: optional functional units supported by this implementation
 */
#define FU_SUP		(SES_FUD_FD | SES_FUD_HD | SES_FUD_SY | SES_FUD_ACT | \
			    SES_FUD_CD | SES_FUD_TD | SES_FUD_EXCPT)

#define SET_FINAL(p)	((p)->flags |= SESF_FINAL)
#define IS_FINAL(p)	(((p)->flags & SESF_FINAL) && !(p)->tp_queue && !(p)->su_queue)

#define SET_CLDONE(p)	((p)->flags |= SESF_CLDONE)
#define CLR_CLIENT(p)	(((p)->flags & SESF_CLDONE) && !(p)->su_queue)
/*
 * Session fsm transition routine dispatcher
 */
extern int	ses_fsm();
#define SES_FSM(event, pcb, pargs, m) ses_fsm(event, pcb, pargs, m)


/*
 * Session machine predicates. See protocol definition
 */
#define FU(fu, pcb)      	(((pcb)->fu_sel & (fu)) != 0)

#define TK_MEMBER(tk, tkset)	(((tk) & (tkset)) != 0)

#define TK_AV(tk, pcb)		TK_MEMBER(tk, (pcb)->tk_avail)
#define TK_OWNED(tk, pcb)	TK_MEMBER(tk, (pcb)->tk_own)

#define TK_I(tk, pcb)	(((~(pcb)->tk_avail |  (pcb)->tk_own) & (tk)) != 0)
#define TK_A(tk, pcb)	(((~(pcb)->tk_avail | ~(pcb)->tk_own) & (tk)) != 0)
#define TK_II(tk, pcb)	((( (pcb)->tk_avail &  (pcb)->tk_own) & (tk)) != 0)
#define TK_AA(tk, pcb)	((( (pcb)->tk_avail & ~(pcb)->tk_own) & (tk)) != 0)

#define TK_ANY_AV(tkset, pcb)	TK_AV((tkset), (pcb))
#define TK_ANY_I(tkset, pcb)	TK_I((tkset), (pcb))
#define TK_ANY_A(tkset, pcb)	TK_A((tkset), (pcb))
#define TK_ANY_II(tkset, pcb)	TK_II((tkset), (pcb))
#define TK_ANY_AA(tkset, pcb)	TK_AA((tkset), (pcb))

#define TK_ALL_I(tkset, pcb)	(!TK_ANY_AA((tkset), (pcb)))
#define TK_ALL_A(tkset, pcb)	(!TK_ANY_II((tkset), (pcb)))
#define TK_ALL_II(tkset, pcb)	(!TK_ANY_A((tkset), (pcb)))
#define TK_ALL_AA(tkset, pcb)	(!TK_ANY_I((tkset), (pcb)))

/*
 * Assert predicates
 */
#define BETWEEN(a, l, u) \
	(((unsigned)(a) >= (unsigned)(l)) && ((unsigned)(a) <= (unsigned)(u)))
#define IS_SIDU_EV(e)	BETWEEN((e), SIDU_AA, SIDU_TD)
#define IS_SU_EV(e)	BETWEEN((e), SU_CON_REQ, SU_UER_REQ)
#define IS_TS_EV(e)	BETWEEN((e), TS_CON_IND, TS_DIS_IND)
#define IS_SY_EV(e)	(int)((e) == SY_TIM_IND)

#define IS_SODU_EV(e)	BETWEEN((e), SODU_AA, SODU_TD)
#define IS_SS_EV(e)	BETWEEN((e), SS_CON_CNF_A, SS_UER_IND)
#define IS_TU_EV(e)	BETWEEN((e), TU_CON_REQ, TU_DAT_REQ)

/*
 * Other useful macros
 */

#define LINK_MBUF(head, new) \
	{ \
		(new)->m_next = head; \
		head = new; \
	}

#define SET_STATE(state)	(0)		/* save state for reflect */
#define SET_SI(si)		(0)		/* save si for reflect */
#define SET_EVENT(event)	(0)		/* save event for reflect */



/*
 * transition routines 
 */
int tr000(); int tr001(); int tr002(); int tr003(); int tr004();
int tr005(); int tr006(); int tr007(); int tr008(); int tr009();
int tr010(); int tr011(); int tr012(); int tr013(); int tr014();
int tr015(); int tr016(); int tr017(); int tr018(); int tr019();
int tr020(); int tr021(); int tr022(); int tr023(); int tr024();
int tr025(); int tr026(); int tr027(); int tr028(); int tr029();
int tr030(); int tr031(); int tr032(); int tr033(); int tr034();
int tr035(); int tr036(); int tr037(); int tr038(); int tr039();
int tr040(); int tr041(); int tr042(); int tr043(); int tr044();
int tr045(); int tr046(); int tr047(); int tr048(); int tr049();
int tr050(); int tr051(); int tr052(); int tr053(); int tr054();
int tr055(); int tr056(); int tr057(); int tr058(); int tr059();
int tr060(); int tr061(); int tr062(); int tr063(); int tr064();
int tr065(); int tr066(); int tr067(); int tr068(); int tr069();
int tr070(); int tr071(); int tr072(); int tr073(); int tr074();
int tr075(); int tr076(); int tr077(); int tr078(); int tr079();
int tr080(); int tr081(); int tr082(); int tr083(); int tr084();
int tr085(); int tr086(); int tr087(); int tr088(); int tr089();
int tr090(); int tr091(); int tr092(); int tr093(); int tr094();
int tr095(); int tr096(); int tr097(); int tr098(); int tr099();
int tr100(); int tr101(); int tr102(); int tr103(); int tr104();

